#ifndef __MY_ELEMENT_H__
#define __MY_ELEMENT_H__

// This is needed in case you want to utilize this header file
// outside of the kernel ...
#ifndef __KERNEL__
#define __KERNEL__
#include <linux/list.h>
#undef __KERNEL__
#else
#include <linux/list.h>
#endif

/*
 * adopted from code off of LKML
 * Bill Wendling (wendling_at_ganymede.isdn.uiuc.edu)
 * http://lists.insecure.org/lists/linux-kernel/2000/Feb/0472.html
 * (Improved <linux/lists.h> thread in Feb 2000)
 */
#define FOR_EACH(pos, head) \
	for (pos = (head)->next; pos != (head); pos = pos->next)
#define FOR_EACH_REVERSE(pos, head) \
	for (pos = (head)->prev; pos != (head); pos = pos->prev)

/*
 * Here we define the little element that will
 * make up the list of elements we use later ...
 *
 * Please note that the list_head comes first ...
 * you must *always* have this as the first element
 */
struct my_element {
	struct list_head	list;
	unsigned int		val;
};

#endif // __MY_ELEMENT_H__
